#pragma once

#include "pages_conserving.h"
#include "pipe_opener_interface.h"
#include "pipe_paging.h"
#include "resource.h"

/* Support for providing access to pipes. */

class PipeOpenerResource : public Resource, public PipeOpener
{
protected:
    PagesConserving *_pages;

    long open_endpoint(PipePaging *paging, bool writer, l4_cap_idx_t *endpoint);

public:
    explicit PipeOpenerResource(PagesConserving *pages);

    /* Server details. */

    int expected_items();

    ipc_server_handler_type handler();

    void *interface()
    { return static_cast<PipeOpener *>(this); }

    /* PipeOpener interface methods. */

    long pipe(l4_cap_idx_t *reader, l4_cap_idx_t *writer);
};

// vim: tabstop=4 expandtab shiftwidth=4
